(function (Drupal, once) {

  function isValidHttpUrl(string, base) {
    let url;
    try {
      url = new URL(string, base);
    } catch (_) {
      return false;
    }
    return url.protocol === 'http:' || url.protocol === 'https:';
  }

  Drupal.behaviors.klaroSanitize = {
    attach(context) {
      once('klaro-sanitize', 'a[data-href]', context).forEach((anchor) => {
        const dataHref = anchor.getAttribute('data-href');
        if (!isValidHttpUrl(dataHref, context.location.origin)) {
          anchor.setAttribute('data-href', '#');
        }
      });
    }
  };

}(Drupal, once));
